/**
 * EIVLTS.java
 *
 * File generated from the datatypes::EIVLTS uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.ips.datatypes;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class EIVLTS.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "EIVL_TS", propOrder = {
	"event",
	"offset"
})
@XmlRootElement(name = "EIVL_TS")
public class EIVLTS extends net.ihe.gazelle.ips.datatypes.SXCMTS implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *  A code for a common (periodical) activity of daily living based on which the event related periodic interval is specified. .
	 */
	@XmlElement(name = "event", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.ips.datatypes.EIVLEvent event;
	/**
	 *  An interval of elapsed time (duration, not absolute point in time) that marks the offsets for the beginning, width and end of the event-related periodic interval measured from the time each such event actually occurred. .
	 */
	@XmlElement(name = "offset", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.ips.datatypes.IVLPQ offset;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return event.
	 * @return event :  A code for a common (periodical) activity of daily living based on which the event related periodic interval is specified. 
	 */
	public net.ihe.gazelle.ips.datatypes.EIVLEvent getEvent() {
	    return event;
	}
	
	/**
	 * Set a value to attribute event.
	 * @param event :  A code for a common (periodical) activity of daily living based on which the event related periodic interval is specified. .
	 */
	public void setEvent(net.ihe.gazelle.ips.datatypes.EIVLEvent event) {
	    this.event = event;
	}
	
	
	
	
	/**
	 * Return offset.
	 * @return offset :  An interval of elapsed time (duration, not absolute point in time) that marks the offsets for the beginning, width and end of the event-related periodic interval measured from the time each such event actually occurred. 
	 */
	public net.ihe.gazelle.ips.datatypes.IVLPQ getOffset() {
	    return offset;
	}
	
	/**
	 * Set a value to attribute offset.
	 * @param offset :  An interval of elapsed time (duration, not absolute point in time) that marks the offsets for the beginning, width and end of the event-related periodic interval measured from the time each such event actually occurred. .
	 */
	public void setOffset(net.ihe.gazelle.ips.datatypes.IVLPQ offset) {
	    this.offset = offset;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.ips.datatypes");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "EIVL_TS").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(EIVLTS eIVLTS, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (eIVLTS != null){
   			net.ihe.gazelle.ips.datatypes.SXCMTS.validateByModule(eIVLTS, _location, cvm, diagnostic);
			net.ihe.gazelle.ips.datatypes.EIVLEvent.validateByModule(eIVLTS.getEvent(), _location + "/event", cvm, diagnostic);
			net.ihe.gazelle.ips.datatypes.IVLPQ.validateByModule(eIVLTS.getOffset(), _location + "/offset", cvm, diagnostic);
    	}
    }

}